import c, { Component, useState, useCallback, useRef } from 'react';
import { render } from 'react-dom';
import { cx, css } from 'emotion';
import { CheckCircleIcon, WarningIcon, ErrorCircleIcon, InfoCircleIcon, CloseIcon } from '@contentful/f36-icons';
import { Button } from '@contentful/f36-button';
import { TextLink } from '@contentful/f36-text-link';
import { Flex, Box } from '@contentful/f36-core';
import { Heading, Paragraph } from '@contentful/f36-typography';
import a from '@contentful/f36-tokens';
import wt from 'react-animate-height';

var ot=Object.defineProperty,it=Object.defineProperties;var et=Object.getOwnPropertyDescriptors;var b=Object.getOwnPropertySymbols;var U=Object.prototype.hasOwnProperty,j=Object.prototype.propertyIsEnumerable;var X=(t,o,i)=>o in t?ot(t,o,{enumerable:!0,configurable:!0,writable:!0,value:i}):t[o]=i,m=(t,o)=>{for(var i in o||(o={}))U.call(o,i)&&X(t,i,o[i]);if(b)for(var i of b(o))j.call(o,i)&&X(t,i,o[i]);return t},f=(t,o)=>it(t,et(o));var I=(t,o)=>{var i={};for(var r in t)U.call(t,r)&&o.indexOf(r)<0&&(i[r]=t[r]);if(t!=null&&b)for(var r of b(t))o.indexOf(r)<0&&j.call(t,r)&&(i[r]=t[r]);return i};function $(t){let o=useRef(t),[,i]=useState(!1);return [o,s=>{Object.is(o.current,s)||(o.current=s,i(d=>!d));}]}var q={positive:a.green600,negative:a.red600,warning:a.orange400,primary:a.blue600},at=({variant:t})=>css({background:a.colorWhite,borderRadius:a.borderRadiusMedium,boxShadow:a.boxShadowHeavy,boxSizing:"border-box",display:"flex",overflow:"hidden",position:"relative",padding:a.spacingM,width:"100%","&:before":{backgroundColor:q[t],content:'""',height:"100%",left:0,position:"absolute",top:0,width:"2px"}}),st=({variant:t})=>css({fill:q[t],marginRight:a.spacingM,alignItems:"flex-start"}),_=({variant:t})=>({wrapper:at({variant:t}),icon:st({variant:t}),notification:css({fontSize:a.fontSizeM,lineHeight:a.lineHeightM,width:"100%"}),title:css({color:a.gray800,fontSize:a.fontSizeL,lineHeight:a.lineHeightL}),content:css({color:a.gray700,wordBreak:"break-word",hyphens:"auto","&:last-child":{marginBottom:0}}),closeButton:css({marginBottom:`-${a.spacingXs}`,marginRight:`-${a.spacingXs}`,marginTop:`-${a.spacingXs}`})});var xt=(t,o)=>{var x;let e=t,{className:i,children:r,cta:s,withCloseButton:d=!0,closeButtonAriaLabel:B="Dismiss",variant:l="positive",onClose:v,testId:y="cf-ui-notification",title:w}=e,D=I(e,["className","children","cta","withCloseButton","closeButtonAriaLabel","variant","onClose","testId","title"]),u=_({variant:l}),P=w?"medium":"small",E={positive:c.createElement(CheckCircleIcon,{variant:l,size:P}),warning:c.createElement(WarningIcon,{variant:l,size:P}),negative:c.createElement(ErrorCircleIcon,{variant:l,size:P}),primary:c.createElement(InfoCircleIcon,{variant:l,size:P})};return c.createElement(Flex,f(m({"data-test-id":y,role:"alert","data-intent":{positive:"success",warning:"warning",negative:"error",primary:"info"}[l],"aria-live":l==="positive"?"polite":"assertive",className:cx(u.wrapper,i)},D),{ref:o}),c.createElement(Box,{className:cx(u.icon)},E[l]),c.createElement(Box,{className:cx(u.notification)},w&&c.createElement(Heading,{as:"h2",className:cx(u.title),marginBottom:"spacingXs"},w),r&&c.createElement(Paragraph,{className:u.content,marginBottom:"spacingXs"},r),(s==null?void 0:s.label)&&c.createElement(TextLink,f(m({},s==null?void 0:s.textLinkProps),{as:((x=s==null?void 0:s.textLinkProps)==null?void 0:x.as)||"button"}),s.label)),d&&c.createElement(Box,null,c.createElement(Button,{className:cx(u.closeButton),variant:"transparent",startIcon:c.createElement(CloseIcon,null),onClick:()=>{v&&v();},testId:"cf-ui-notification-close","aria-label":B})))},T=c.forwardRef(xt);var vt={isShown:!1},N=class extends Component{constructor(){super(...arguments);this.timer=null;this.state={isShown:!1};this.startTimer=()=>{if(this.props.duration){if(this.props.duration===0)return;this.timer=window.setTimeout(()=>{this.handleClose();},this.props.duration);}};this.stopTimer=()=>{this.props.duration!==0&&this.timer&&(clearTimeout(this.timer),this.timer=null);};this.handleClose=()=>{this.stopTimer(),this.setState({isShown:!1});};this.handleMouseEnter=()=>{this.stopTimer();};this.handleMouseLeave=()=>{this.startTimer();};}componentDidMount(){this.startTimer(),this.setState({isShown:!0});}componentDidUpdate(i){i.isShown!==this.props.isShown&&this.setState({isShown:this.props.isShown});}componentWillUnmount(){this.stopTimer();}render(){let d=this.props,s=I(d,["isShown","duration"]);return c.createElement(wt,{duration:200,height:this.state.isShown?"auto":0,easing:"ease-in-out",animateOpacity:!0,onHeightAnimationEnd:()=>{this.state.isShown===!1&&this.props.onClose&&this.props.onClose();}},c.createElement("div",{className:cx(css({pointerEvents:"all"})),onMouseEnter:this.handleMouseEnter,onMouseLeave:this.handleMouseLeave},c.createElement(T,f(m({},s),{onClose:this.handleClose}))))}};N.defaultProps=vt;var J=(t,o)=>({manager:css({left:0,margin:"0 auto",maxWidth:"560px",position:"fixed",pointerEvents:"none",right:0,[t]:o,zIndex:a.zIndexNotification}),container:css({display:"flex",flexDirection:"column",margin:"0 auto",maxWidth:"560px",minWidth:"360px","& > div":{marginBottom:t==="top"?0:a.spacingS,marginTop:t==="top"?a.spacingS:0}})});var Q=0,yt=()=>(Q+=1,Q),M=({register:t})=>{let[o,i]=$([]),[r,s]=useState("bottom"),[d,B]=useState(20),[l,v]=useState(6e3),y=J(r,d),w=useCallback((n,e)=>{if(n==="bottom"||n==="top"){let x=e&&e.offset?e.offset:20;s(n),B(x);}},[]),D=useCallback(n=>{i(o.current.map(e=>e.id!==n?e:f(m({},e),{isShown:!1})));},[o,i]),u=useCallback(n=>{i(o.current.filter(e=>e.id!==n));},[o,i]),P=useCallback(()=>{i(o.current.map(n=>f(m({},n),{isShown:!1})));},[o,i]),E=useCallback((n,e)=>{let x=e&&typeof e.duration!="undefined"?e.duration:l,Z=e!=null&&e.variant?e.variant:"positive",R=e&&typeof e.withClose!="undefined"?e.withClose:!0,W=e!=null&&e.id?e.id:yt(),A={id:W,text:n,onClose:()=>u(W),duration:x,withClose:R,isShown:!0,variant:Z,title:e==null?void 0:e.title,cta:e==null?void 0:e.cta},O=o.current.find(tt=>tt.id===A.id);return O||(i(r==="top"?[A,...o.current]:[...o.current,A]),A)},[u,l,o,r,i]);return t("close",D),t("show",E),t("closeAll",P),t("setPlacement",w),t("setDuration",v),c.createElement("div",{"data-test-id":"cf-notification-container",className:cx(y.manager)},c.createElement("div",{className:cx(y.container)},o.current.map(n=>c.createElement(N,{variant:n.variant,duration:n.duration,key:n.id,withCloseButton:n.withClose,onClose:n.onClose,isShown:n.isShown,title:n.title,cta:n.cta},n.text))))};M.displayName="NotificationsManager";var Y=!1,p={};function It(t,o){p[t]=o;}function Tt(t){let o=document.createElement("div");document.body.appendChild(o),render(c.createElement(M,{register:It}),o,t);}function h(t){return (...o)=>Y?Promise.resolve(t(...o)):(Y=!0,new Promise(i=>{Tt(()=>{i(t(...o));});}))}var V=t=>(o,i)=>{if(p.show)return p.show(o,f(m({},i||{}),{variant:t}))},Mt={success:h(V("positive")),error:h(V("negative")),warning:h(V("warning")),info:h(V("primary")),close:h(t=>{if(p.close)return p.close(t)}),closeAll:h(()=>{if(p.closeAll)return p.closeAll()}),setPlacement:h((t,o)=>{if(p.setPlacement)return p.setPlacement(t,o)}),setDuration:h(t=>{if(p.setDuration)return p.setDuration(t)})};

export { Mt as Notification, T as NotificationItem, N as NotificationItemContainer, M as NotificationsManager };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.js.map